/* maratona.c
 *
 * Determina la classifica e i vincitori della maratona di New York.
 */

#include <stdio.h>
#include <string.h>

#define MAX_NOME 35
#define MAX_TIPO 1
#define MAX_TEMPO 8

#define MAX_ATLETI 1000
#define NOME_FILE_IN "maratona.txt"
#define NOME_FILE_OUT "vincitori.txt"

struct atleta {
	char cognome[MAX_NOME + 1];
	char nome[MAX_NOME + 1];
	char tipo[MAX_TIPO + 1];
	char tempo[MAX_TEMPO + 1];
};

// Funzione ausiliaria di insertion-sort

int inserisci_atleta(struct atleta vett[], int dim, struct atleta a) {
	int i = dim;

	while (i > 0 && strcmp(vett[i-1].tempo, a.tempo) > 0) {
		vett[i] = vett[i-1];
		i--;
	}

	vett[i] = a;

	return dim+1;
}

void stampa_classifica(struct atleta vett[], int dim) {
	// Per comodita' di lettura si rende piu' compatta la tabella
	// riducendo le ampiezze di cognome e nome
	
	for(int i = 0; i < dim; i++)
		printf("%3d %-*s %-*s   %*s\n",
			i+1,
			MAX_NOME-15, vett[i].cognome,
		    MAX_NOME-15, vett[i].nome,
			MAX_TEMPO, vett[i].tempo
		);
}

void scrivi_vincitori(struct atleta vinc_m, struct atleta vinc_f) {
	FILE *fp;
	if ((fp = fopen(NOME_FILE_OUT, "w")) == NULL) {
		printf("Impossibile creare il file dei vincitori.\n");
		return;
	}
	
	fprintf(fp, "%s\t%s\t%s\n", vinc_m.cognome, vinc_m.nome, vinc_m.tempo);
	fprintf(fp, "%s\t%s\t%s\n", vinc_f.cognome, vinc_f.nome, vinc_f.tempo);
	
	fclose(fp);
}

int main( void ) {
	struct atleta tab_m[MAX_ATLETI], tab_f[MAX_ATLETI];
	int dim_m = 0, dim_f = 0;
	FILE *fp;
	struct atleta a;
	
	if ((fp = fopen(NOME_FILE_IN, "r")) == NULL) {
		printf("Errore nell'apertura del file.\n");
		return 1;
	}
	
	while (fscanf(fp, "%s%s%s%s", a.cognome, a.nome, a.tipo, a.tempo) > 0) {
		if (strcmp(a.tipo, "F") == 0)
			dim_f = inserisci_atleta(tab_f, dim_f, a);
		else
			dim_m = inserisci_atleta(tab_m, dim_m, a);
	}
	fclose(fp);
	
	printf("Classifica maschile\n");
	printf("========================================================\n");
	
	stampa_classifica(tab_m, dim_m);

	printf("\n\nClassifica femminile\n");
	printf("========================================================\n");

	stampa_classifica(tab_f, dim_f);
	
	if (dim_m == 0 || dim_f == 0)
		printf("Impossibile determinare i vincitori delle due gare.\n");
	else
		scrivi_vincitori(tab_m[0], tab_f[0]);
		
    return 0;
}

